Index: /LMDZ6/branches/LMDZ_ECRad/libf/misc/readTracFiles_mod.f90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/misc/readTracFiles_mod.f90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/misc/readTracFiles_mod.f90	(revision 4727)
@@ -114,9 +114,9 @@
   !--- SOME PARAMETERS THAT ARE NOT LIKELY TO CHANGE OFTEN
   CHARACTER(LEN=maxlen), SAVE      :: tran0        = 'air'      !--- Default transporting fluid
-  CHARACTER(LEN=maxlen), PARAMETER :: old_phases   = 'vlir'     !--- Old phases for water (no separator)
-  CHARACTER(LEN=maxlen), PARAMETER :: known_phases = 'glsr'     !--- Known phases initials
+  CHARACTER(LEN=maxlen), PARAMETER :: old_phases   = 'vlirb'     !--- Old phases for water (no separator)
+  CHARACTER(LEN=maxlen), PARAMETER :: known_phases = 'glsrb'     !--- Known phases initials
   INTEGER, PARAMETER :: nphases = LEN_TRIM(known_phases)        !--- Number of phases
   CHARACTER(LEN=maxlen), SAVE      :: phases_names(nphases) &   !--- Known phases names
-                                             = ['gaseous', 'liquid ', 'solid  ', 'cloud  ']
+                                = ['gaseous', 'liquid ', 'solid  ', 'cloud  ','blosno ']
   CHARACTER(LEN=1), SAVE :: phases_sep  =  '_'                  !--- Phase separator
   LOGICAL,          SAVE :: tracs_merge = .TRUE.                !--- Merge/stack tracers lists
Index: /LMDZ6/branches/LMDZ_ECRad/libf/misc/wxios.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/misc/wxios.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/misc/wxios.F90	(revision 4727)
@@ -1,14 +1,6 @@
 ! $Id$
-#ifdef CPP_XIOS
+
 MODULE wxios
-    USE xios
-    USE iaxis
-    USE iaxis_attr
-    USE icontext_attr
-    USE idate
-    USE idomain_attr
-    USE ifield_attr
-    USE ifile_attr
-    USE ixml_tree
+    USE lmdz_xios
 
     !Variables disponibles pendant toute l'execution du programme:
@@ -159,4 +151,6 @@
         g_ctx = xios_ctx
 
+        CALL wxios_add_group_init
+        
         IF (prt_level >= 10) THEN
           WRITE(lunout,*) "wxios_context_init: Current context is ",trim(g_ctx_name)
@@ -168,4 +162,116 @@
     END SUBROUTINE wxios_context_init
 
+
+    
+    SUBROUTINE wxios_add_group_init
+
+      ! routine create by Anne Cozic (2023)
+      ! This routine will create field associated to group defined without description of fields in field.xml file
+      ! This routine need to be call before "xios_sole_inheritance" after an !$OMP MASTER directive 
+      
+      USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niso, ntiso
+      USE strings_mod,  ONLY: maxlen
+
+      IMPLICIT NONE
+
+      TYPE(xios_fieldgroup) :: group_handle, philev_hdl
+      TYPE(xios_field) :: child
+      INTEGER :: k, iq
+      CHARACTER(len=12) :: nvar, name_phi    
+      CHARACTER(LEN=maxlen) :: varname, dn
+      CHARACTER(LEN=maxlen) :: unt
+    
+
+      ! group create for StratAER variables 
+      !On ajoute les variables 3D traceurs par l interface fortran 
+      CALL xios_get_handle("fields_strataer_trac_3D", group_handle)
+      ! On boucle sur les traceurs pour les ajouter au groupe puis fixer les attributs
+      DO iq = 1, nqtot
+         IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
+         dn = 'd'//TRIM(tracers(iq)%name)//'_'
+
+         unt = "kg kg-1"
+         varname=trim(tracers(iq)%name)
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         
+         unt = "kg kg-1 s-1"
+         varname=TRIM(dn)//'vdf'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'the'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'con'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'lessi_impa'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'lessi_nucl'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'insc'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'bcscav'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'evapls'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'ls'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'trsp'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'sscav'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'sat'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         varname=TRIM(dn)//'uscav'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+      END DO
+      !On ajoute les variables 2D traceurs par l interface fortran 
+      CALL xios_get_handle("fields_strataer_trac_2D", group_handle)
+      ! On boucle sur les traceurs pour les ajouter au groupe puis fixer les attributs
+      DO iq = 1, nqtot
+         IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
+         
+         unt = "kg m-2"
+         varname='cum'//trim(tracers(iq)%name)
+         
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+         
+         unt = "kg m-2 s-1"
+         varname='cumd'//trim(tracers(iq)%name)//'_dry'
+         CALL xios_add_child(group_handle, child, varname)
+         CALL xios_set_attr(child, name=varname, unit=unt)
+      ENDDO
+      
+
+      ! group create for offline mass flow variables
+      CALL xios_get_handle("philev_grp", philev_hdl)
+
+      DO k=1,79
+         IF (k<10) THEN
+            WRITE(nvar,'(i1)') k
+         ELSE IF (k<100) THEN
+            WRITE(nvar,'(i2)') k
+         ELSE
+            WRITE(nvar,'(i3)') k
+         END IF
+         name_phi= "phi_lev"//TRIM(nvar)
+         CALL xios_add_child(philev_hdl, child, "phi_lev"//TRIM(nvar)) 
+         CALL xios_set_attr(child, name=trim(name_phi))
+      ENDDO
+
+
+    END SUBROUTINE wxios_add_group_init
 
     SUBROUTINE wxios_set_context()
@@ -297,10 +403,10 @@
         
         !On récupère le handle:
-        CALL xios_get_domain_handle(dom_id, dom)
+        CALL xios_get_handle(dom_id, dom)
         
         !On parametrise le domaine:
-        CALL xios_set_domain_attr_hdl(dom, ni_glo=nbp_lon, ibegin=0, ni=nbp_lon, type="rectilinear")
-        CALL xios_set_domain_attr_hdl(dom, nj_glo=nbp_lat, jbegin=jj_begin-1, nj=jj_nb, data_dim=2)
-        CALL xios_set_domain_attr_hdl(dom, lonvalue_1d=io_lon(1:nbp_lon), latvalue_1d=io_lat(jj_begin:jj_end))
+        CALL xios_set_attr(dom, ni_glo=nbp_lon, ibegin=0, ni=nbp_lon, type="rectilinear")
+        CALL xios_set_attr(dom, nj_glo=nbp_lat, jbegin=jj_begin-1, nj=jj_nb, data_dim=2)
+        CALL xios_set_attr(dom, lonvalue_1d=io_lon(1:nbp_lon), latvalue_1d=io_lat(jj_begin:jj_end))
         CALL xios_set_domain_attr("dom_out", domain_ref=dom_id)
 
@@ -324,8 +430,8 @@
               WRITE(lunout,*) "wxios_domain_param: mpirank=",mpi_rank," mask(:,jj_nb)=",mask(:,jj_nb)
             ENDIF
-            CALL xios_set_domain_attr_hdl(dom, mask_2d=mask)
-        END IF
-
-         CALL xios_is_defined_domain_attr_hdl(dom,ni_glo=boool)
+            CALL xios_set_attr(dom, mask_2d=mask)
+        END IF
+
+         CALL xios_is_defined_attr(dom,ni_glo=boool)
         !Vérification:
         IF (xios_is_valid_domain(dom_id)) THEN
@@ -366,5 +472,5 @@
 
 !$OMP MASTER
-        CALL xios_get_domain_handle(dom_id, dom)
+        CALL xios_get_handle(dom_id, dom)
         
         !On parametrise le domaine:
@@ -466,6 +572,6 @@
         IF (.NOT.xios_is_valid_file(fname)) THEN
             !On créé le noeud:
-            CALL xios_get_filegroup_handle("defile", x_fg)
-            CALL xios_add_file(x_fg, x_file, fname)
+            CALL xios_get_handle("defile", x_fg)
+            CALL xios_add_child(x_fg, x_file, fname)
         
             !On reformate la fréquence:
@@ -473,5 +579,5 @@
         
             !On configure:
-            CALL xios_set_file_attr_hdl(x_file, name="X"//fname,&
+            CALL xios_set_attr(x_file, name="X"//fname,&
                 output_freq=nffreq, output_level=flvl, enabled=.TRUE.)
        
@@ -522,9 +628,9 @@
         
         !On ajoute le champ:
-        CALL xios_add_field(fieldgroup, field, fieldname)
+        CALL xios_add_child(fieldgroup, field, fieldname)
         !IF (prt_level >= 10) WRITE(lunout,*) "wxios_add_field: ",fieldname,fieldgroup, fieldlongname, fieldunit
         
         !On rentre ses paramètres:
-        CALL xios_set_field_attr_hdl(field, standard_name=fieldlongname, unit=newunit, default_value=def)
+        CALL xios_set_attr(field, standard_name=fieldlongname, unit=newunit, default_value=def)
         IF (prt_level >= 10) WRITE(lunout,*) "wxios_add_field: Field ",trim(fieldname), "cree:"
         IF (prt_level >= 10) WRITE(lunout,*) "wxios_add_field: long_name=",trim(fieldlongname),"; unit=",trim(newunit),";  default_value=",nf90_fill_real
@@ -577,7 +683,7 @@
         !On selectionne le bon groupe de champs:
         IF (fdim.EQ.2) THEN
-          CALL xios_get_fieldgroup_handle("fields_2D", fieldgroup)
+          CALL xios_get_handle("fields_2D", fieldgroup)
         ELSE
-          CALL xios_get_fieldgroup_handle("fields_3D", fieldgroup)
+          CALL xios_get_handle("fields_3D", fieldgroup)
         ENDIF
         
@@ -608,15 +714,15 @@
             !Champ existe déjà, mais pas XML, alors on l'ajoute
             !On ajoute le champ:
-            CALL xios_get_file_handle(fname, f)
-            CALL xios_add_fieldtofile(f, field)
+            CALL xios_get_handle(fname, f)
+            CALL xios_add_child(f, field)
             
             
             !L'operation, sa frequence:
             freq_op%timestep=1
-            CALL xios_set_field_attr_hdl(field, field_ref=fieldname, operation=TRIM(ADJUSTL(operation)), freq_op=freq_op, prec=4)
+            CALL xios_set_attr(field, field_ref=fieldname, operation=TRIM(ADJUSTL(operation)), freq_op=freq_op, prec=4)
 
             
             !On rentre ses paramètres:
-            CALL xios_set_field_attr_hdl(field, level=field_level, enabled=.TRUE.)
+            CALL xios_set_attr(field, level=field_level, enabled=.TRUE.)
             
             IF (fdim.EQ.2) THEN
@@ -630,5 +736,5 @@
                 !Si 3D :
                 !On ajoute l'axe vertical qui va bien:
-                CALL xios_set_field_attr_hdl(field, axis_ref=TRIM(ADJUSTL(axis_id)))
+                CALL xios_set_attr(field, axis_ref=TRIM(ADJUSTL(axis_id)))
                 
                 IF (prt_level >= 10) THEN
@@ -678,3 +784,3 @@
      END SUBROUTINE wxios_close
 END MODULE wxios
-#endif
+
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/abort_physic.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/abort_physic.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/abort_physic.F90	(revision 4727)
@@ -38,20 +38,20 @@
       if (ierr .eq. 0) then
         write(lunout,*) 'Everything is cool'
-#ifdef CPP_MPI
-        !$OMP CRITICAL (MPI_ABORT_PHYSIC)
-        call MPI_ABORT(COMM_LMDZ_PHY, 0, ierror_mpi)
-        !$OMP END CRITICAL (MPI_ABORT_PHYSIC)
-#else
-        stop 0
-#endif          
+        if (using_mpi) then
+          !$OMP CRITICAL (MPI_ABORT_PHYSIC)
+          call MPI_ABORT(COMM_LMDZ_PHY, 0, ierror_mpi)
+          !$OMP END CRITICAL (MPI_ABORT_PHYSIC)
+        else
+          stop 0
+        endif          
       else
         write(lunout,*) 'Houston, we have a problem, ierr = ', ierr
-#ifdef CPP_MPI
-!$OMP CRITICAL (MPI_ABORT_PHYSIC)
-        call MPI_ABORT(COMM_LMDZ_PHY, 1, ierror_mpi)
-!$OMP END CRITICAL (MPI_ABORT_PHYSIC)
-#else
-        stop 1
-#endif          
+        if (using_mpi) then
+          !$OMP CRITICAL (MPI_ABORT_PHYSIC)
+          call MPI_ABORT(COMM_LMDZ_PHY, 1, ierror_mpi)
+          !$OMP END CRITICAL (MPI_ABORT_PHYSIC)
+        else
+          stop 1
+        endif          
       endif
       END
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/mod_phys_lmdz_mpi_data.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/mod_phys_lmdz_mpi_data.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/mod_phys_lmdz_mpi_data.F90	(revision 4727)
@@ -3,5 +3,6 @@
 !
 MODULE mod_phys_lmdz_mpi_data
-  
+  USE lmdz_mpi 
+
   INTEGER,SAVE :: ii_begin
   INTEGER,SAVE :: ii_end
@@ -47,9 +48,6 @@
   
   SUBROUTINE init_phys_lmdz_mpi_data(nbp, nbp_lon, nbp_lat, nbp_lev, grid_type, nvertex, communicator)
-
+  USE lmdz_mpi
   IMPLICIT NONE
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
     INTEGER,INTENT(IN) :: nbp
     INTEGER,INTENT(IN) :: nbp_lon
@@ -65,9 +63,5 @@
     INTEGER :: i
     
-#ifdef CPP_MPI
-    is_using_mpi=.TRUE.
-#else
-    is_using_mpi=.FALSE.
-#endif
+    is_using_mpi = using_mpi
     
     if ((nbp_lon.eq.1).and.(nbp_lat.eq.1)) then ! running 1D column model
@@ -82,9 +76,7 @@
 
     IF (is_using_mpi) THEN    
-#ifdef CPP_MPI
       MPI_REAL_LMDZ=MPI_REAL8
       CALL MPI_COMM_SIZE(COMM_LMDZ_PHY,mpi_size,ierr)    
       CALL MPI_COMM_RANK(COMM_LMDZ_PHY,mpi_rank,ierr)
-#endif
     ELSE
       mpi_size=1
@@ -95,7 +87,5 @@
 
     IF (is_using_mpi) THEN    
-#ifdef CPP_MPI
-    CALL MPI_ALLGATHER(nbp,1,MPI_INTEGER,distrib,1,MPI_INTEGER,COMM_LMDZ_PHY,ierr)
-#endif
+      CALL MPI_ALLGATHER(nbp,1,MPI_INTEGER,distrib,1,MPI_INTEGER,COMM_LMDZ_PHY,ierr)
     ELSE
      distrib(:)=nbp
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90	(revision 4727)
@@ -1367,4 +1367,5 @@
   SUBROUTINE bcast_mpi_cgen(var,nb)
     USE mod_phys_lmdz_mpi_data 
+    USE lmdz_mpi
     IMPLICIT NONE
     
@@ -1372,14 +1373,9 @@
     INTEGER,INTENT(IN) :: nb
     
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
     INTEGER :: ierr
 
     IF (.not.is_using_mpi) RETURN
     
-#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_CHARACTER,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
         
   END SUBROUTINE bcast_mpi_cgen
@@ -1389,4 +1385,5 @@
   SUBROUTINE bcast_mpi_igen(var,nb)
     USE mod_phys_lmdz_mpi_data
+    USE lmdz_mpi
     IMPLICIT NONE
     
@@ -1394,14 +1391,9 @@
     INTEGER,DIMENSION(nb),INTENT(INOUT) :: Var
     
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
     INTEGER :: ierr
 
     IF (.not.is_using_mpi) RETURN
 
-#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_INTEGER,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
         
   END SUBROUTINE bcast_mpi_igen
@@ -1412,4 +1404,5 @@
   SUBROUTINE bcast_mpi_rgen(var,nb)
     USE mod_phys_lmdz_mpi_data
+    USE lmdz_mpi
     IMPLICIT NONE
     
@@ -1417,14 +1410,9 @@
     REAL,DIMENSION(nb),INTENT(INOUT) :: Var
     
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
     INTEGER :: ierr
 
     IF (.not.is_using_mpi) RETURN
 
-#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_REAL_LMDZ,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
     
   END SUBROUTINE bcast_mpi_rgen
@@ -1435,4 +1423,5 @@
   SUBROUTINE bcast_mpi_lgen(var,nb)
     USE mod_phys_lmdz_mpi_data
+    USE lmdz_mpi
     IMPLICIT NONE
     
@@ -1440,14 +1429,9 @@
     LOGICAL,DIMENSION(nb),INTENT(INOUT) :: Var
     
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
     INTEGER :: ierr
 
     IF (.not.is_using_mpi) RETURN
 
-#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_LOGICAL,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
 
   END SUBROUTINE bcast_mpi_lgen
@@ -1458,4 +1442,5 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
+    USE lmdz_mpi
     IMPLICIT NONE
   
@@ -1464,7 +1449,4 @@
     INTEGER,INTENT(OUT),DIMENSION(klon_mpi,dimsize) :: VarOut
   
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
     INTEGER,DIMENSION(0:mpi_size-1) :: displs
     INTEGER,DIMENSION(0:mpi_size-1) :: counts
@@ -1493,8 +1475,6 @@
     ENDIF
       
-#ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_INTEGER,VarOut,klon_mpi*dimsize,   &
                       MPI_INTEGER,mpi_master, COMM_LMDZ_PHY,ierr)
-#endif
 
   END SUBROUTINE scatter_mpi_igen
@@ -1503,4 +1483,5 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
+    USE lmdz_mpi
     IMPLICIT NONE
   
@@ -1508,8 +1489,4 @@
     REAL,INTENT(IN),DIMENSION(klon_glo,dimsize) :: VarIn
     REAL,INTENT(OUT),DIMENSION(klon_mpi,dimsize) :: VarOut
-  
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
 
     INTEGER,DIMENSION(0:mpi_size-1) :: displs
@@ -1537,10 +1514,7 @@
     ENDIF
       
-#ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_REAL_LMDZ,VarOut,klon_mpi*dimsize,   &
                       MPI_REAL_LMDZ,mpi_master, COMM_LMDZ_PHY,ierr)
 
-#endif
-
   END SUBROUTINE scatter_mpi_rgen
 
@@ -1549,4 +1523,5 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
+    USE lmdz_mpi
     IMPLICIT NONE
   
@@ -1555,7 +1530,4 @@
     LOGICAL,INTENT(OUT),DIMENSION(klon_mpi,dimsize) :: VarOut
   
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
 
     INTEGER,DIMENSION(0:mpi_size-1) :: displs
@@ -1583,8 +1555,6 @@
     ENDIF
       
-#ifdef CPP_MPI
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_LOGICAL,VarOut,klon_mpi*dimsize,   &
                       MPI_LOGICAL,mpi_master, COMM_LMDZ_PHY,ierr)
-#endif
 
   END SUBROUTINE scatter_mpi_lgen  
@@ -1596,10 +1566,7 @@
     USE mod_phys_lmdz_mpi_data
     USE mod_grid_phy_lmdz
-    IMPLICIT NONE
-  
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
-    
+    USE lmdz_mpi
+    IMPLICIT NONE
+  
     INTEGER,INTENT(IN) :: dimsize
     INTEGER,INTENT(IN),DIMENSION(klon_mpi,dimsize) :: VarIn
@@ -1628,8 +1595,6 @@
     ENDIF
     
-#ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_INTEGER,VarTmp,counts,displs,   &
                      MPI_INTEGER,mpi_master, COMM_LMDZ_PHY,ierr)
-#endif
 
                           
@@ -1650,10 +1615,7 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
-    IMPLICIT NONE
-  
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
-    
+    USE lmdz_mpi
+    IMPLICIT NONE
+  
     INTEGER,INTENT(IN) :: dimsize
     REAL,INTENT(IN),DIMENSION(klon_mpi,dimsize) :: VarIn
@@ -1681,8 +1643,6 @@
     ENDIF
 
-#ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_REAL_LMDZ,VarTmp,counts,displs,   &
                       MPI_REAL_LMDZ,mpi_master, COMM_LMDZ_PHY,ierr)
-#endif
                           
     IF (is_mpi_root) THEN
@@ -1702,4 +1662,5 @@
     USE mod_phys_lmdz_mpi_data
     USE mod_grid_phy_lmdz
+    USE lmdz_mpi
     IMPLICIT NONE
   
@@ -1707,8 +1668,4 @@
     LOGICAL,INTENT(IN),DIMENSION(klon_mpi,dimsize) :: VarIn
     LOGICAL,INTENT(OUT),DIMENSION(klon_glo,dimsize) :: VarOut
-  
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
 
     INTEGER,DIMENSION(0:mpi_size-1) :: displs
@@ -1734,8 +1691,6 @@
     
 
-#ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_LOGICAL,VarTmp,counts,displs,   &
                       MPI_LOGICAL,mpi_master, COMM_LMDZ_PHY,ierr)
-#endif
                           
     IF (is_mpi_root) THEN
@@ -1757,9 +1712,6 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
-    IMPLICIT NONE
-    
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
+    USE lmdz_mpi
+    IMPLICIT NONE
    
     INTEGER,INTENT(IN) :: nb
@@ -1774,7 +1726,5 @@
 
 
-#ifdef CPP_MPI
     CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_INTEGER,MPI_SUM,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
             
   END SUBROUTINE reduce_sum_mpi_igen
@@ -1783,11 +1733,7 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
-
-    IMPLICIT NONE
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
-    
+    USE lmdz_mpi
+    IMPLICIT NONE
+
     INTEGER,INTENT(IN) :: nb
     REAL,DIMENSION(nb),INTENT(IN) :: VarIn
@@ -1800,7 +1746,5 @@
     ENDIF
    
-#ifdef CPP_MPI
     CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_REAL_LMDZ,MPI_SUM,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
         
   END SUBROUTINE reduce_sum_mpi_rgen
@@ -1811,10 +1755,7 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
-    IMPLICIT NONE
-    
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
-   
+    USE lmdz_mpi
+    IMPLICIT NONE
+    
     INTEGER,INTENT(IN) :: nb
     INTEGER,DIMENSION(nb),INTENT(IN) :: VarIn
@@ -1828,7 +1769,5 @@
 
 
-#ifdef CPP_MPI
     CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_INTEGER,MPI_MIN,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
             
   END SUBROUTINE reduce_min_mpi_igen
@@ -1837,11 +1776,8 @@
     USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
-
-    IMPLICIT NONE
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
-    
+    USE lmdz_mpi
+
+    IMPLICIT NONE
+
     INTEGER,INTENT(IN) :: nb
     REAL,DIMENSION(nb),INTENT(IN) :: VarIn
@@ -1854,7 +1790,5 @@
     ENDIF
    
-#ifdef CPP_MPI
     CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_REAL_LMDZ,MPI_MIN,mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
         
   END SUBROUTINE reduce_min_mpi_rgen
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phydev/iophy.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phydev/iophy.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phydev/iophy.F90	(revision 4727)
@@ -13,27 +13,13 @@
   
 
-#ifdef CPP_XIOS
 ! interfaces for both IOIPSL and XIOS
   INTERFACE histwrite_phy
     MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy,histwrite2d_xios,histwrite3d_xios
   END INTERFACE
-#else
-! interfaces for IOIPSL
-  INTERFACE histwrite_phy
-    MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy
-  END INTERFACE
-#endif
-
-#ifdef CPP_XIOS
+
 ! interfaces for both IOIPSL and XIOS
   INTERFACE histbeg_phy_all
     MODULE PROCEDURE histbeg_phy, histbeg_phyxios
   END INTERFACE
-#else
-! interfaces for IOIPSL
-  INTERFACE histbeg_phy_all
-    MODULE PROCEDURE histbeg_phy
-  END INTERFACE
-#endif
 
 contains
@@ -51,7 +37,5 @@
   USE ioipsl, only: flio_dom_set
 #endif
-#ifdef CPP_XIOS
-  use wxios, only: wxios_domain_param
-#endif
+  use wxios, only: wxios_domain_param, using_xios
   implicit none
     real,dimension(klon),intent(in) :: rlon
@@ -122,32 +106,32 @@
                       'APPLE',phys_domain_id)
 #endif
-#ifdef CPP_XIOS
-    ! Set values for the mask:
-    IF (mpi_rank == 0) THEN
-        data_ibegin = 0
-    ELSE 
-        data_ibegin = ii_begin - 1
-    END IF
-
-    IF (mpi_rank == mpi_size-1) THEN
-        data_iend = nbp_lon
-    ELSE
-        data_iend = ii_end + 1
-    END IF
-
-    if (prt_level>=10) then
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," iibegin=",ii_begin , " ii_end=",ii_end," jjbegin=",jj_begin," jj_nb=",jj_nb," jj_end=",jj_end
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," nbp_lon=",nbp_lon," nbp_lat=",nbp_lat
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole=",is_south_pole_dyn
-    endif
-
-    ! Initialize the XIOS domain coreesponding to this process:
-    CALL wxios_domain_param("dom_glo", is_sequential, nbp_lon, jj_nb, nbp_lon, nbp_lat, &
-                            1, nbp_lon, ii_begin, ii_end, jj_begin, jj_end,             &
-                            klon_mpi+2*(nbp_lon-1), data_ibegin, data_iend,             &
-                            io_lat, io_lon,is_south_pole_dyn,mpi_rank)
-#endif
+    IF (using_xios) THEN
+      ! Set values for the mask:
+      IF (mpi_rank == 0) THEN
+          data_ibegin = 0
+      ELSE 
+          data_ibegin = ii_begin - 1
+      END IF
+
+      IF (mpi_rank == mpi_size-1) THEN
+          data_iend = nbp_lon
+      ELSE
+          data_iend = ii_end + 1
+      END IF
+
+      if (prt_level>=10) then
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," iibegin=",ii_begin , " ii_end=",ii_end," jjbegin=",jj_begin," jj_nb=",jj_nb," jj_end=",jj_end
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," nbp_lon=",nbp_lon," nbp_lat=",nbp_lat
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
+        write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole=",is_south_pole_dyn
+      endif
+
+      ! Initialize the XIOS domain coreesponding to this process:
+      CALL wxios_domain_param("dom_glo", is_sequential, nbp_lon, jj_nb, nbp_lon, nbp_lat, &
+                              1, nbp_lon, ii_begin, ii_end, jj_begin, jj_end,             &
+                              klon_mpi+2*(nbp_lon-1), data_ibegin, data_iend,             &
+                              io_lat, io_lon,is_south_pole_dyn,mpi_rank)
+    ENDIF
 !$OMP END MASTER
       
@@ -184,5 +168,4 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-#ifdef CPP_XIOS
 
 ! SUBROUTINE histbeg_phyxios(name,itau0,zjulian,dtime,ffreq,lev,nhori,nid_day)
@@ -213,5 +196,4 @@
   END SUBROUTINE histbeg_phyxios
 
-#endif
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -339,10 +321,10 @@
 
 ! VERSION DES HISTWRITE DEDIEES AU TOUT-XIOS-XML DEJA UTILISEE DANS PHYDEV
-#ifdef CPP_XIOS
+
   SUBROUTINE histwrite2d_xios(field_name,field)
   USE dimphy, only: klon
   USE mod_phys_lmdz_para, only: gather_omp, grid1Dto2D_mpi, &
                                 jj_nb, klon_mpi
-  USE xios, only: xios_send_field
+  USE lmdz_xios, only: xios_send_field
   USE print_control_mod, ONLY: prt_level, lunout
   USE mod_grid_phy_lmdz, ONLY: nbp_lon
@@ -368,15 +350,14 @@
     IF (prt_level >= 10) WRITE(lunout,*)'End histrwrite2d_xios ',trim(field_name)
   END SUBROUTINE histwrite2d_xios
-#endif
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
 ! VERSION DES HISTWRITE DEDIEES AU TOUT-XIOS-XML DEJA UTILISEE DANS PHYDEV
-#ifdef CPP_XIOS
+
   SUBROUTINE histwrite3d_xios(field_name, field)
   USE dimphy, only: klon, klev
   USE mod_phys_lmdz_para, only: gather_omp, grid1Dto2D_mpi, &
                                 jj_nb, klon_mpi
-  USE xios, only: xios_send_field
+  USE lmdz_xios, only: xios_send_field
   USE print_control_mod, ONLY: prt_level,lunout
   USE mod_grid_phy_lmdz, ONLY: nbp_lon
@@ -407,5 +388,4 @@
     IF (prt_level >= 10) write(lunout,*)'End histrwrite3d_xios ',trim(field_name)
   END SUBROUTINE histwrite3d_xios
-#endif
 
 end module iophy
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phydev/physiq_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phydev/physiq_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phydev/physiq_mod.F90	(revision 4727)
@@ -23,9 +23,7 @@
       USE mod_grid_phy_lmdz, ONLY: nbp_lon,nbp_lat
 
-#ifdef CPP_XIOS
-      USE xios, ONLY: xios_update_calendar
+      USE lmdz_xios, ONLY: xios_update_calendar, using_xios
       USE wxios, only: wxios_add_vaxis, wxios_set_cal, wxios_closedef
       USE iophy, ONLY: histwrite_phy
-#endif
 
       IMPLICIT none
@@ -126,15 +124,15 @@
 #endif
 
-#ifdef CPP_XIOS
+    IF (using_xios) THEN
 !XIOS
-    ! Declare available vertical axes to be used in output files:    
-    CALL wxios_add_vaxis("presnivs", klev, presnivs)
+      ! Declare available vertical axes to be used in output files:    
+      CALL wxios_add_vaxis("presnivs", klev, presnivs)
 
-    ! Declare calendar and time step
-    CALL wxios_set_cal(dtime,"earth_360d",1,1,1,0.0,1,1,1,0.0)
+      ! Declare calendar and time step
+      CALL wxios_set_cal(dtime,"earth_360d",1,1,1,0.0,1,1,1,0.0)
     
-    !Finalize the context:
-    CALL wxios_closedef()
-#endif
+      !Finalize the context:
+      CALL wxios_closedef()
+    ENDIF
 !$OMP END MASTER
 !$OMP BARRIER
@@ -176,10 +174,10 @@
 
 !XIOS
-#ifdef CPP_XIOS
-!$OMP MASTER
+IF (using_xios) THEN
+  !$OMP MASTER
     !Increment XIOS time
     CALL xios_update_calendar(itau)
-!$OMP END MASTER
-!$OMP BARRIER
+  !$OMP END MASTER
+  !$OMP BARRIER
 
     !Send fields to XIOS: (NB these fields must also be defined as
@@ -190,5 +188,5 @@
     CALL histwrite_phy("v",v)
     CALL histwrite_phy("ps",paprs(:,1))
-#endif
+ENDIF
 
 ! if lastcall, then it is time to write "restartphy.nc" file
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/aeropt_spl.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/aeropt_spl.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/aeropt_spl.F	(revision 4727)
@@ -12,8 +12,8 @@
       IMPLICIT none
 c
-#include "chem.h"
-#include "dimensions.h"
-c #include "dimphy.h"
-#include "YOMCST.h"
+      INCLUDE "chem.h"
+      INCLUDE "dimensions.h"
+cINCLUDE "dimphy.h"
+      INCLUDE "YOMCST.h"
 c
 c Arguments:
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/bcscav_spl.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/bcscav_spl.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/bcscav_spl.F	(revision 4727)
@@ -9,8 +9,8 @@
 c=====================================================================
 c
-#include "dimensions.h"
-#include "chem.h"
-#include "YOMCST.h"
-#include "YOECUMF.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "chem.h"
+      INCLUDE "YOMCST.h"
+      INCLUDE "YOECUMF.h"
 c
       REAL pdtime, alpha_r, alpha_s, R_r, R_s 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/bl_for_dms.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/bl_for_dms.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/bl_for_dms.F	(revision 4727)
@@ -17,8 +17,8 @@
 c===================================================================
 c
-#include "dimensions.h"
-#include "YOMCST.h"
-#include "YOETHF.h"
-#include "FCTTRE.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "YOMCST.h"
+      INCLUDE "YOETHF.h"
+      INCLUDE "FCTTRE.h"
 c
 c Arguments :
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/blcloud_scav.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/blcloud_scav.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/blcloud_scav.F	(revision 4727)
@@ -10,8 +10,8 @@
       IMPLICIT NONE
 
-#include "dimensions.h"
-#include "chem.h"
-#include "YOMCST.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "chem.h"
+      INCLUDE "YOMCST.h"
+      INCLUDE "paramet.h"
 
 c============================= INPUT ===================================
